#function to slice content, taking words surrounding
#a particular phrase
slicer <- function(content, phrases, context=5){
  
  #get first words of phrases, all words
  #of content
  words <- sapply(strsplit(phrases, "_"), "[[", 1)
  c_splt <- unlist(strsplit(content, " "))
  
  #get location of first matched word
  #word_loc <- match(word, c_splt)
  word_loc <- grep(paste(words, collapse="|"), 
                   c_splt)[1]
  
  #get surrounding locations
  begin <- max(1, (word_loc-context))
  end <- min(length(c_splt), word_loc+context)
  
  #get slice
  slice <- c_splt[begin:end]
  slice <- paste(slice, collapse = " ")
  return(slice)
  
}

#function to check which event week a date falls into
event_week <- function(date, df_prepost, topic){
  
  #get slice of the pre-post event week df pertaining to the topic
  df_prepost <- df_prepost[df_prepost$topic %in% topic,]
  
  #convert date to Date-type object
  date <- as.Date(date)
  
  #check if date falls in pre-event week, post-event week, or neither
  week <- "none"
  for(i in 1:nrow(df_prepost)){
    
    if(date >= as.Date(df_prepost$pre_start[i]) & 
         date <= as.Date(df_prepost$pre_end[i])){
      week <- paste0(df_prepost$event_abbr[i], "_pre")
      break
    } else if (date >= as.Date(df_prepost$post_start[i]) & 
                 date <= as.Date(df_prepost$post_end[i])) {
      week <- paste0(df_prepost$event_abbr[i], "_post")
      break
    }
    
  }
  
  return(week)
  
}
